// UniqueNames.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace std;

bool doDirectory(string strDirectory, set<string> &fileNames, int &iSkips, int &iRenames);

int main(int argc, char* argv[])
{
	set<string> fileNames;
	int iSkips = 0;
	int iRenames = 0;

	if (argc != 2)
	{
		printf("Give directory path as argument.\n");
	}
	else if (!doDirectory(argv[1], fileNames, iSkips, iRenames))
	{
		printf("\n\n***Failed*** (Done %d. Skipped %d.)\n\n", iRenames, iSkips);
	}
	else
	{
		printf("\n\n(Done %d. Skipped %d.)\n\n", iRenames, iSkips);
	}

	return(0);
}

bool doDirectory(string strDirectory, set<string> &fileNames, int &iSkips, int &iRenames)
{
	bool result = true;

	set<string> dirs;
	set<string> files;

	struct _finddata_t fileinfo;

	string strSearchPath = strDirectory;
	strSearchPath += "\\*.*";

	long fr = _findfirst(strSearchPath.c_str(), &fileinfo);

	if ((-1) == fr)
	{
		printf("ERROR scanning for %s\n", strSearchPath.c_str());
		result = false;
	}
	else
	{
		do
		{
			if (fileinfo.attrib & _A_SUBDIR)
			{
				if (strcmp(".", fileinfo.name) && strcmp("..", fileinfo.name))
				{
					dirs.insert(fileinfo.name);
				}
			}
			else
			{
				files.insert(fileinfo.name);
			}
		} while (0 == _findnext(fr, &fileinfo));

		_findclose(fr);

		while (! files.empty() )
		{
			string fileName = *(files.begin());
			files.erase(files.begin());

			char szTemp[32];
			string::size_type dotPos;
			bool bRename = false;
			int iRenameNumber = 0;
			string fileNameRenamed = fileName;

			while(files.find(fileNameRenamed) != files.end() || (!fileNames.insert(fileNameRenamed).second))
			{
				bRename = true;
				fileNameRenamed = fileName;

				dotPos = fileNameRenamed.rfind('.');

				if (dotPos != string::npos)
				{
					fileNameRenamed.insert(dotPos, itoa(iRenameNumber++, szTemp, 16));
					fileNameRenamed.insert(dotPos, "_n");
				}
				else
				{
					fileNameRenamed += "_n";
					fileNameRenamed += itoa(iRenameNumber++, szTemp, 16);
				}
			}

			if (bRename)
			{
				string strOldPath = strDirectory;
				strOldPath += "\\";
				strOldPath += fileName;

				string strNewPath = strDirectory;
				strNewPath += "\\";
				strNewPath += fileNameRenamed;

				if (!MoveFile(strOldPath.c_str(), strNewPath.c_str()))
				{
					printf("\n\n*** Failed to rename: %s\n to %s\n\n", strOldPath.c_str(), strNewPath.c_str());

					result = false;

					break;
				}
				else
				{
					printf("Renamed %s to %s\n", fileName.c_str(), fileNameRenamed.c_str());
					iRenames++;
				}
			}
			else
			{
				iSkips++;
			}
		}
	
		while (! dirs.empty() )
		{
			string strDirPath = strDirectory;
			strDirPath += "\\";
			strDirPath += dirs.begin()->c_str();

			if (! doDirectory(strDirPath, fileNames, iSkips, iRenames) )
			{
				result = false;

				break;
			}

			dirs.erase(dirs.begin());
		}
	}

	return(result);
}
